import _objectSpread from "@babel/runtime/helpers/esm/objectSpread";
import _slicedToArray from "@babel/runtime/helpers/esm/slicedToArray";
import React, { Fragment, useState, memo } from "react";
import SidebarBoxContainer from "../SidebarBoxContainer";
import { makeStyles } from "@mui/styles";
import { createTheme, ThemeProvider } from "@mui/material/styles";
import { styled } from "@mui/material/styles";
import { grey } from "@mui/material/colors";
import RegionIcon from "@mui/icons-material/PictureInPicture";
import Grid from "@mui/material/Grid";
import ReorderIcon from "@mui/icons-material/SwapVert";
import PieChartIcon from "@mui/icons-material/PieChart";
import TrashIcon from "@mui/icons-material/Delete";
import LockIcon from "@mui/icons-material/Lock";
import UnlockIcon from "@mui/icons-material/LockOpen";
import VisibleIcon from "@mui/icons-material/Visibility";
import VisibleOffIcon from "@mui/icons-material/VisibilityOff";
import styles from "./styles";
import classnames from "classnames";
import isEqual from "lodash/isEqual";
import LabelFilterMenu from "../LabelFilterMenu";
import ArrowForwardIosSharpIcon from "@mui/icons-material/ArrowForwardIosSharp";
import LabelIcon from "@mui/icons-material/Label";
import CommentIcon from "@mui/icons-material/Comment";
import DisabledCommentIcon from "@mui/icons-material/CommentsDisabled";
import FileIcon from "@mui/icons-material/InsertDriveFile";
import LaunchIcon from "@mui/icons-material/Launch";
import MuiAccordion from "@mui/material/Accordion";
import MuiAccordionSummary from "@mui/material/AccordionSummary";
import MuiAccordionDetails from "@mui/material/AccordionDetails";
import { colors } from "../colors";
import { useEffect } from "react";
import SidebarBox from "../SidebarBox";
import { Autocomplete, Box, IconButton, TextField, Tooltip } from "@mui/material";
import Select from "react-select";
import { asMutable } from "seamless-immutable";
var theme = createTheme();
var useStyles = makeStyles(function (theme) {
  return styles;
});
var HeaderSep = styled("div")(function (_ref) {
  var theme = _ref.theme;
  return {
    borderTop: "1px solid ".concat(grey[200]),
    marginTop: 2,
    marginBottom: 2
  };
});

var Chip = function Chip(_ref2) {
  var regionID = _ref2.regionID,
      color = _ref2.color,
      text = _ref2.text;
  var classes = useStyles();
  return React.createElement("span", {
    className: classes.chip
  }, React.createElement("div", {
    className: "color",
    style: {
      backgroundColor: color
    }
  }), React.createElement("div", {
    "data-id": regionID,
    className: "text"
  }, text));
};

var RowLayout = function RowLayout(_ref3) {
  var header = _ref3.header,
      highlighted = _ref3.highlighted,
      order = _ref3.order,
      classification = _ref3.classification,
      area = _ref3.area,
      tags = _ref3.tags,
      trash = _ref3.trash,
      lock = _ref3.lock,
      comment = _ref3.comment,
      visible = _ref3.visible,
      onClick = _ref3.onClick,
      regionClsList = _ref3.regionClsList,
      cls = _ref3.cls,
      onChangeRegion = _ref3.onChangeRegion,
      region = _ref3.region,
      allowComments = _ref3.allowComments;
  var classes = useStyles();

  var _useState = useState(false),
      _useState2 = _slicedToArray(_useState, 2),
      mouseOver = _useState2[0],
      changeMouseOver = _useState2[1]; // console.log(region)


  return React.createElement("div", {
    onClick: onClick,
    onMouseEnter: function onMouseEnter() {
      return changeMouseOver(true);
    },
    onMouseLeave: function onMouseLeave() {
      return changeMouseOver(false);
    },
    className: classnames(classes.row, {
      header: header,
      highlighted: highlighted
    }),
    style: {
      paddingLeft: "10px"
    }
  }, React.createElement(Grid, {
    container: true,
    alignItems: "center"
  }, React.createElement(Grid, {
    item: true,
    xs: 2
  }, React.createElement("div", {
    style: {
      textAlign: "right",
      paddingRight: 10
    }
  }, order)), React.createElement(Grid, {
    item: true,
    xs: 5
  }, classification), React.createElement(Grid, {
    item: true,
    xs: 2
  }, React.createElement("div", {
    style: {
      textAlign: "right",
      paddingRight: 6
    }
  }, area)), React.createElement(Grid, {
    item: true,
    xs: 1
  }, trash), allowComments ? React.createElement(Grid, {
    item: true,
    xs: 1
  }, comment) : React.createElement(Grid, {
    item: true,
    xs: 1
  }, lock), React.createElement(Grid, {
    item: true,
    xs: 1
  }, visible)), region.showComment && React.createElement(Box, {
    sx: {
      display: "flex",
      border: "1px solid #a8a8a8",
      borderRadius: "2px",
      maxHeight: "3rem",
      overflow: "hidden",
      m: "6px",
      p: "6px"
    }
  }, region.comment));
};

var RowHeader = function RowHeader() {
  return React.createElement(RowLayout, {
    header: true,
    highlighted: false,
    order: React.createElement(ReorderIcon, {
      className: "icon"
    }),
    classification: React.createElement("div", {
      style: {
        paddingLeft: 10
      }
    }, "Class"),
    area: React.createElement(PieChartIcon, {
      className: "icon"
    }),
    trash: React.createElement(TrashIcon, {
      className: "icon"
    }),
    lock: React.createElement(LockIcon, {
      className: "icon"
    }),
    visible: React.createElement(VisibleIcon, {
      className: "icon"
    }),
    comment: React.createElement(CommentIcon, {
      className: "icon"
    })
  });
};

var MemoRowHeader = memo(RowHeader);

var Row = function Row(_ref4) {
  var r = _ref4.region,
      highlighted = _ref4.highlighted,
      onSelectRegion = _ref4.onSelectRegion,
      onDeleteRegion = _ref4.onDeleteRegion,
      onChangeRegion = _ref4.onChangeRegion,
      visible = _ref4.visible,
      locked = _ref4.locked,
      color = _ref4.color,
      cls = _ref4.cls,
      showComment = _ref4.showComment,
      index = _ref4.index,
      regionClsList = _ref4.regionClsList,
      comment = _ref4.comment,
      allowComments = _ref4.allowComments;
  return React.createElement(RowLayout, {
    allowComments: allowComments,
    region: r,
    onChangeRegion: onChangeRegion,
    cls: cls,
    regionClsList: regionClsList,
    header: false,
    highlighted: highlighted,
    onClick: function onClick() {
      return onSelectRegion(r);
    },
    order: "#".concat(index + 1),
    classification: React.createElement(Chip, {
      regionID: r.id,
      text: cls || "",
      color: color || "#ddd"
    }),
    area: "",
    trash: React.createElement(TrashIcon, {
      onClick: function onClick() {
        return onDeleteRegion(r);
      },
      className: "icon2"
    }),
    comment: r.comment ? r.showComment ? React.createElement(DisabledCommentIcon, {
      onClick: function onClick() {
        return onChangeRegion(_objectSpread({}, r, {
          showComment: false
        }));
      },
      className: "icon2"
    }) : React.createElement(CommentIcon, {
      onClick: function onClick() {
        return onChangeRegion(_objectSpread({}, r, {
          showComment: true
        }));
      },
      className: "icon2"
    }) : React.createElement(Tooltip, {
      title: "You can improve the process by adding descriptions to your annotations"
    }, React.createElement(CommentIcon, {
      onClick: function onClick() {
        setTimeout(function () {
          var textArea = document.querySelector('textarea[placeholder="Description..."]');
          textArea && textArea.click();
        }, 200);
      },
      className: "icon3"
    })),
    lock: r.locked ? React.createElement(LockIcon, {
      onClick: function onClick() {
        return onChangeRegion(_objectSpread({}, r, {
          locked: false
        }));
      },
      className: "icon2"
    }) : React.createElement(UnlockIcon, {
      onClick: function onClick() {
        return onChangeRegion(_objectSpread({}, r, {
          locked: true
        }));
      },
      className: "icon2"
    }),
    visible: r.visible || r.visible === undefined ? React.createElement(VisibleIcon, {
      onClick: function onClick() {
        return onChangeRegion(_objectSpread({}, r, {
          visible: false
        }));
      },
      className: "icon2"
    }) : React.createElement(VisibleOffIcon, {
      onClick: function onClick() {
        return onChangeRegion(_objectSpread({}, r, {
          visible: true
        }));
      },
      className: "icon2"
    })
  });
};

var MemoRow = memo(Row, function (prevProps, nextProps) {
  return prevProps.highlighted === nextProps.highlighted && prevProps.visible === nextProps.visible && prevProps.locked === nextProps.locked && prevProps.id === nextProps.id && prevProps.index === nextProps.index && prevProps.cls === nextProps.cls && prevProps.color === nextProps.color && prevProps.showComment === nextProps.showComment && prevProps.comment === nextProps.comment;
});
var emptyArr = [];
export var RegionSelectorSidebarBox = function RegionSelectorSidebarBox(_ref5) {
  var state = _ref5.state,
      dispatch = _ref5.dispatch,
      _ref5$regions = _ref5.regions,
      regions = _ref5$regions === void 0 ? emptyArr : _ref5$regions,
      onDeleteRegion = _ref5.onDeleteRegion,
      onChangeRegion = _ref5.onChangeRegion,
      onSelectRegion = _ref5.onSelectRegion;

  var _useState3 = useState(),
      _useState4 = _slicedToArray(_useState3, 2),
      expandedIndex = _useState4[0],
      setExpandedIndex = _useState4[1];

  var _useState5 = useState({}),
      _useState6 = _slicedToArray(_useState5, 2),
      regionsObject = _useState6[0],
      setRegionsObject = _useState6[1];

  var _useState7 = useState(0),
      _useState8 = _slicedToArray(_useState7, 2),
      filterType = _useState8[0],
      setFilterType = _useState8[1];

  var _useState9 = useState(state.regionClsList),
      _useState10 = _slicedToArray(_useState9, 2),
      filteredRegionClsList = _useState10[0],
      setFilteredRegionClsList = _useState10[1];

  var classes = useStyles();

  var getRemainingLabels = function getRemainingLabels() {
    var regionClsList = state.regionClsList;
    var regionClsObject = {};
    regionClsList.forEach(function (cls) {
      regionClsObject[cls] = false;
    });
    state.images.forEach(function (img) {
      if (img.regions) {
        img.regions.forEach(function (region) {
          if (region.cls) {
            regionClsObject[region.cls] = true;
          }
        });
      }
    });
    setRegionsObject(regionClsObject);
    return "(".concat(Object.values(regionClsObject).filter(function (region) {
      return region;
    }).length, "/").concat(Object.keys(regionClsObject).length, ")");
  };

  var getRegionColorByCls = function getRegionColorByCls(cls) {
    var regionClsList = state.regionClsList;
    var index = regionClsList.findIndex(function (regionCls) {
      return regionCls === cls;
    });
    return colors[index];
  };

  var getSubString = function getSubString(text, max) {
    return text.length > max ? text.slice(0, max) + "..." : text;
  };

  useEffect(function () {
    getRemainingLabels();
  }, [regions]);
  useEffect(function () {
    var preventScroll = function preventScroll() {
      var selectButton = document.querySelector('button[aria-label="Select"');
      selectButton.click();
    };

    preventScroll();
  }, []);
  useEffect(function () {
    switch (filterType) {
      case 0:
        var allRegions = state.regionClsList;
        setFilteredRegionClsList(allRegions);
        break;

      case 1:
        var labeledRegions = [];

        for (var _i = 0, _Object$entries = Object.entries(regionsObject); _i < _Object$entries.length; _i++) {
          var _ref8 = _Object$entries[_i];

          var _ref7 = _slicedToArray(_ref8, 2);

          var key = _ref7[0];
          var value = _ref7[1];

          if (value) {
            labeledRegions.push(key);
          }
        }

        setFilteredRegionClsList(labeledRegions);
        break;

      case 2:
        var unlabeledRegions = [];

        for (var _i2 = 0, _Object$entries2 = Object.entries(regionsObject); _i2 < _Object$entries2.length; _i2++) {
          var _ref11 = _Object$entries2[_i2];

          var _ref10 = _slicedToArray(_ref11, 2);

          var _key = _ref10[0];
          var _value = _ref10[1];

          if (!_value) {
            unlabeledRegions.push(_key);
          }
        }

        setFilteredRegionClsList(unlabeledRegions);
        break;

      default:
        break;
    }
  }, [filterType, regionsObject]);
  return React.createElement(ThemeProvider, {
    theme: theme
  }, React.createElement(SidebarBox, {
    info: React.createElement(LabelFilterMenu, {
      filterType: filterType,
      setFilterType: setFilterType
    }),
    title: "Labels (".concat(Object.values(regionsObject).filter(function (region) {
      return region;
    }).length, "/").concat(Object.keys(regionsObject).length, ")"),
    subTitle: "",
    icon: React.createElement(RegionIcon, {
      style: {
        color: grey[700]
      }
    }),
    expandedByDefault: true
  }, React.createElement("div", {
    className: classes.container
  }, filteredRegionClsList.map(function (r, i) {
    return React.createElement(Accordion, {
      key: i,
      disabled: !regionsObject[r]
    }, React.createElement(AccordionSummary, null, React.createElement(LabelIcon, {
      fontSize: "small",
      sx: {
        color: getRegionColorByCls(r)
      }
    }), React.createElement("span", {
      style: {
        display: "flex",
        alignItems: "center",
        fontSize: "14px"
      }
    }, r)), React.createElement(AccordionDetails, null, state.images.map(function (img, i) {
      if (img.regions) {
        if (img.regions.find(function (region) {
          return region.cls === r;
        })) {
          return React.createElement(Accordion, {
            key: i,
            sx: {
              "& .MuiAccordionSummary-root": {
                p: 0,
                pl: "30px",
                minHeight: "40px"
              }
            }
          }, React.createElement(AccordionSummary, null, React.createElement(Box, {
            sx: {
              display: "flex",
              alignItems: "center",
              gap: "6px",
              width: "100%"
            }
          }, React.createElement(FileIcon, {
            fontSize: "small",
            sx: {
              color: "#757575"
            }
          }), React.createElement("span", {
            style: {
              display: "flex",
              alignItems: "center",
              fontSize: "12px"
            }
          }, getSubString(img.name, 18)), state.selectedImage !== state.images.findIndex(function (i) {
            return i.name === img.name;
          }) && React.createElement(Tooltip, {
            title: "Go to image"
          }, React.createElement(IconButton, {
            onClick: function onClick(e) {
              e.stopPropagation();
              var imageIndex = state.images.findIndex(function (i) {
                return i.name === img.name;
              });
              dispatch({
                type: "SELECT_IMAGE",
                imageIndex: imageIndex,
                image: state.images[imageIndex]
              });
            },
            sx: {
              ml: "auto",
              mr: "18px"
            }
          }, React.createElement(LaunchIcon, {
            fontSize: "small",
            sx: {}
          }))))), React.createElement(AccordionDetails, null, img.regions.filter(function (region) {
            return region.cls === r;
          }).map(function (region, i) {
            return React.createElement(MemoRow, Object.assign({
              key: region.id
            }, region, {
              region: region,
              index: i,
              onSelectRegion: onSelectRegion,
              onDeleteRegion: onDeleteRegion,
              onChangeRegion: onChangeRegion,
              regionClsList: state.regionClsList,
              allowComments: state.allowComments
            }));
          })));
        }
      }
    })));
  }))));
};
var Accordion = styled(function (props) {
  return React.createElement(MuiAccordion, Object.assign({
    disableGutters: true,
    square: true
  }, props));
})(function (_ref12) {
  var theme = _ref12.theme;
  return {
    borderTop: "1px solid #a8a8a8",
    "&:before": {
      display: "none"
    },
    "& .MuiCollapse-vertical": {
      overflow: "hidden"
    }
  };
});
var AccordionSummary = styled(function (props) {
  return React.createElement(MuiAccordionSummary, Object.assign({
    expandIcon: React.createElement(ArrowForwardIosSharpIcon, {
      sx: {
        fontSize: "0.9rem"
      }
    })
  }, props));
})(function (_ref13) {
  var theme = _ref13.theme;
  return {
    flexDirection: "row-reverse",
    "& .MuiAccordionSummary-expandIconWrapper.Mui-expanded": {
      transform: "rotate(90deg)"
    },
    margin: 0,
    "& .MuiAccordionSummary-content": {
      display: "flex",
      alignItems: "center",
      gap: "6px",
      margin: 0
    },
    "& .MuiAccordionSummary-content.Mui-expanded": {
      margin: 0
    }
  };
});
var AccordionDetails = styled(MuiAccordionDetails)(function (_ref14) {
  var theme = _ref14.theme;
  return {
    borderTop: "1px solid rgba(0, 0, 0, .125)",
    padding: 0
  };
});

var mapUsedRegionProperties = function mapUsedRegionProperties(r) {
  return [r.id, r.color, r.locked, r.visible, r.highlighted, r.showComment, r.comment];
};

export default memo(RegionSelectorSidebarBox, function (prevProps, nextProps) {
  return isEqual((prevProps.regions || emptyArr).map(mapUsedRegionProperties), (nextProps.regions || emptyArr).map(mapUsedRegionProperties));
});